{system/include/sp-AllObjects-def.i}

DEF VAR clogFile AS CHAR NO-UNDO.
DEF VAR dc_CR_CC AS DECIMAL NO-UNDO. 
DEF VAR dc_DB_CC AS DECIMAL NO-UNDO. 

/* Tracht ontkoppelde posten te koppelen aan de bijbehoren result-post */

OUTPUT TO VALUE(SESSION:TEMP-DIR + 'aa-fin-bbx-migratie.result-post.log' ).

DEFINE BUFFER b-payable_dossier-result FOR aa-fin_payable_dossier .
DEFINE BUFFER b-payable-remaining      FOR aa-fin_payable_dossier .
DEF VAR dcRemaining AS DECIMAL NO-UNDO.

FOR EACH aa-fin_parameter NO-LOCK:
  
  sp-companycode = aa-fin_parameter.COMPANYCODE .
  
  /* Tracht migratie posten te verbinden aan de gemigreerde result-post. */
DEF VAR cStatus AS CHAR FORMAT 'X(12)' NO-UNDO.
  
  DISPLAY (aa-fin_parameter.companycode + ' ' + aa-fin_parameter.EXP_results_transcode ) @ cSTATUS .
  
  tr_Result:
  FOR EACH b-payable_dossier-result 
     WHERE b-payable_dossier-result.companycode      EQ aa-fin_parameter.companycode
       AND b-payable_dossier-result.statuscode       EQ 'P'
       AND b-payable_dossier-result.processnr        EQ 1 
       AND b-payable_dossier-result.RESULT_processnr EQ 0
       AND b-payable_dossier-result.TRANSACTIONcode  EQ aa-fin_parameter.EXP_results_transcode
    EXCLUSIVE-LOCK
    TRANSACTION
    ON ERROR UNDO tr_Result , NEXT tr_Result :
      
      /* LLE : onderstaande sequence code is een bug, maar elders ook zo gebruikt. 
               t.z.t. gelijktrekken.                                                  */
      { system/include/sp-seq.i &value           = next
                            &seq-code            = b-payable_dossier-result.companycode + '.ProcessNr'
                            &veld                = b-payable_dossier-result.RESULT_processnr
                            &create_if_not_exist = YES   }
      
      ASSIGN
        b-payable_dossier-result.processnr = b-payable_dossier-result.RESULT_processnr
        .
      
      ASSIGN
        dc_CR_CC = 0
        dc_DB_CC = 0
        .
      
      /* Strategie 0 probeer of er toevallig 1 post is met preicies het juiste bedrag. */
      FIND b-payable-remaining
          WHERE b-payable-remaining.companycode      EQ b-payable_dossier-result.companycode                                   
            AND b-payable-remaining.dossiernr        EQ b-payable_dossier-result.dossiernr                                     
            AND b-payable-remaining.statuscode       EQ 'P'                                                                    
            AND b-payable-remaining.processnr        EQ 1                                                                      
            AND b-payable-remaining.RESULT_processnr EQ 0                                                                      
            AND b-payable-remaining.TRANSACTIONcode  NE b-payable_dossier-result.TRANSACTIONcode                               
            AND b-payable-remaining.amount_CR_CC     EQ b-payable_dossier-result.amount_DB_CC
            AND b-payable-remaining.amount_DB_CC     EQ b-payable_dossier-result.amount_CR_CC
        EXCLUSIVE-LOCK NO-ERROR.
      
      IF AVAIL(b-payable-remaining) 
      THEN DO:
        /* Restant bedrag past precies! */
        ASSIGN
          b-payable-remaining.RESULT_processnr = b-payable_dossier-result.RESULT_processnr
          dc_CR_CC = dc_CR_CC + b-payable-remaining.amount_CR_CC
          dc_DB_CC = dc_DB_CC + b-payable-remaining.amount_DB_CC
          .
        DISPLAY 'Corrected ' @ cStatus b-payable_dossier-result.companycode b-payable_dossier-result.dossiernr  b-payable_dossier-result.seqnr .
        NEXT tr_Result .
      END.
      
      /* startegie 1. */
      ASSIGN
        dc_CR_CC = 0
        dc_DB_CC = 0
        .
      
      ATTACH_payables:
      FOR EACH aa-fin_payable_dossier 
         WHERE aa-fin_payable_dossier.companycode      EQ b-payable_dossier-result.companycode
           AND aa-fin_payable_dossier.dossiernr        EQ b-payable_dossier-result.dossiernr
           AND aa-fin_payable_dossier.statuscode       EQ 'P'
           AND aa-fin_payable_dossier.processnr        EQ 1 
           AND aa-fin_payable_dossier.RESULT_processnr EQ 0
           AND aa-fin_payable_dossier.TRANSACTIONcode  NE b-payable_dossier-result.TRANSACTIONcode
        EXCLUSIVE-LOCK
        
        ON error UNDO tr_Result , NEXT tr_Result  :
        
        ASSIGN
          aa-fin_payable_dossier.RESULT_processnr = b-payable_dossier-result.RESULT_processnr
          dc_CR_CC = dc_CR_CC + aa-fin_payable_dossier.amount_CR_CC
          dc_DB_CC = dc_DB_CC + aa-fin_payable_dossier.amount_DB_CC
          .
        
        dcRemaining = (dc_CR_CC - dc_DB_CC) + ( b-payable_dossier-result.amount_CR_CC - b-payable_dossier-result.amount_DB_CC ) .
        
/*         IF 0 EQ dcRemaining                                                                               */
/*         THEN LEAVE ATTACH_payables .                                                                      */
/*                                                                                                           */
/*         FIND b-payable-remaining                                                                          */
/*           WHERE b-payable-remaining.companycode      EQ b-payable_dossier-result.companycode              */
/*             AND b-payable-remaining.dossiernr        EQ b-payable_dossier-result.dossiernr                */
/*             AND b-payable-remaining.statuscode       EQ 'P'                                               */
/*             AND b-payable-remaining.processnr        EQ 1                                                 */
/*             AND b-payable-remaining.RESULT_processnr EQ 0                                                 */
/*             AND b-payable-remaining.TRANSACTIONcode  NE b-payable_dossier-result.TRANSACTIONcode          */
/*             AND b-payable-remaining.amount_CR_CC     EQ (IF dcRemaining < 0 THEN ABS(dcRemaining) ELSE 0) */
/*             AND b-payable-remaining.amount_DB_CC     EQ (IF dcRemaining < 0 THEN 0 ELSE ABS(dcRemaining)) */
/*         EXCLUSIVE-LOCK NO-ERROR.                                                                          */
/*                                                                                                           */
/*         IF AVAIL(b-payable-remaining)                                                                     */
/*         THEN DO:                                                                                          */
/*           /* Restant bedrag past precies! */                                                              */
/*           ASSIGN                                                                                          */
/*             b-payable-remaining.RESULT_processnr = b-payable_dossier-result.RESULT_processnr              */
/*             dc_CR_CC = dc_CR_CC + b-payable-remaining.amount_CR_CC                                        */
/*             dc_DB_CC = dc_DB_CC + b-payable-remaining.amount_DB_CC                                        */
/*             .                                                                                             */
/*           LEAVE ATTACH_payables .                                                                         */
/*         END.                                                                                              */
        
        
      END.
      
      /* als totaal v/d regels klopt met de 'Ea' regel dan zijn we overtuigd. */
      IF 0 EQ (dc_CR_CC - dc_DB_CC) + ( b-payable_dossier-result.amount_CR_CC - b-payable_dossier-result.amount_DB_CC ) 
      THEN DO:
        DISPLAY 'Corrected ' @ cStatus b-payable_dossier-result.companycode b-payable_dossier-result.dossiernr  b-payable_dossier-result.seqnr .
        NEXT tr-Result .
      END.

      /* startegie 2. o.b.v. boekjaar */
      ASSIGN
        dc_CR_CC = 0
        dc_DB_CC = 0
        .
      
      ATTACH_payables:
      FOR EACH aa-fin_payable_dossier 
         WHERE aa-fin_payable_dossier.companycode      EQ b-payable_dossier-result.companycode
           AND aa-fin_payable_dossier.dossiernr        EQ b-payable_dossier-result.dossiernr
           AND aa-fin_payable_dossier.statuscode       EQ 'P'
           AND aa-fin_payable_dossier.processnr        EQ 1 
           AND aa-fin_payable_dossier.RESULT_processnr EQ 0
           AND aa-fin_payable_dossier.TRANSACTIONcode  NE b-payable_dossier-result.TRANSACTIONcode
           AND aa-fin_payable_dossier.book_acc_year    EQ b-payable_dossier-result.book_acc_year
        EXCLUSIVE-LOCK
        
        ON error UNDO tr_Result , NEXT tr_Result  :
        
        ASSIGN
          aa-fin_payable_dossier.RESULT_processnr = b-payable_dossier-result.RESULT_processnr
          dc_CR_CC = dc_CR_CC + aa-fin_payable_dossier.amount_CR_CC
          dc_DB_CC = dc_DB_CC + aa-fin_payable_dossier.amount_DB_CC
          .
        
        dcRemaining = (dc_CR_CC - dc_DB_CC) + ( b-payable_dossier-result.amount_CR_CC - b-payable_dossier-result.amount_DB_CC ) .
        
      END.
      
      /* als totaal v/d regels klopt met de 'EA' regel dan zijn we overtuigd. */
      IF 0 EQ (dc_CR_CC - dc_DB_CC) + ( b-payable_dossier-result.amount_CR_CC - b-payable_dossier-result.amount_DB_CC ) 
      THEN DO:
        DISPLAY 'Corrected ' @ cStatus b-payable_dossier-result.companycode b-payable_dossier-result.dossiernr  b-payable_dossier-result.seqnr .
        NEXT tr_Result .
      END.
      
      
      DISPLAY 
          '** NOT Corrected ** ' @ cStatus 
          b-payable_dossier-result.companycode b-payable_dossier-result.dossiernr b-payable_dossier-result.seqnr
          dc_CR_CC dc_DB_CC  b-payable_dossier-result.amount_CR_CC b-payable_dossier-result.amount_DB_CC
          WITH WIDTH 156
          .
        
      UNDO tr_Result , NEXT tr_Result .
      
      
      
  END. /* EACH result-post */
  
END. /* each aa-fin_parameter */




