{system/conversion/conversion_progress.i}

/*------------------------------------------------------------------------
  File: aa/conversion/13.02/aa-1302-after-02-pi-vat_value.p
  Doel: Vullen Vat amount op inkoopnota regels
------------------------------------------------------------------------*/
  DEF VAR cProgram                      AS CHAR NO-UNDO.
  DEF VAR cAction                       AS CHAR NO-UNDO.
  DEF VAR iDone                         AS INT  NO-UNDO.
  DEF VAR dVatAmt                       AS DEC NO-UNDO.
  DEF VAR iModulo                       AS INT  NO-UNDO.
  
  DEF BUFFER b-aa-fin_account FOR aa-fin_account.
  DEF BUFFER baa-purchase_invoice FOR aa-purchase_invoice.
  DEF BUFFER baa-purchase_invoice_item FOR aa-purchase_invoice_item.
  
  ASSIGN cProgram =  "aa-1302-after-02-pi-vat_value.p"
         iModulo  =  1000.  /* om de 1000 records info tonen */
  
  FORM "Program  :" AT 1 cProgram   NO-LABEL  FORMAT "x(50)"    AT 12  SKIP
       "Action   :" AT 1 cAction    NO-LABEL  FORMAT "x(50)"    AT 12  SKIP
       "Done     :" AT 1 iDone      NO-LABEL  FORMAT "9999999"  AT 12  SKIP   
       WITH FRAME a.


  ASSIGN cAction  = "Vullen VAT Bedrag op inkoopnota items."
         iDone    = 0.
  RUN DisplayProgress (cProgram, cAction, ''    , 0     , iDone).
  
  DISABLE TRIGGERS FOR LOAD OF baa-purchase_invoice_item.

  FOR EACH sp-company:

    FIND b-aa-fin_account WHERE 
         b-aa-fin_Account.fin_accountcode = sp-company.fin_accountcode
         NO-LOCK NO-ERROR.
    IF AVAIL b-aa-fin_account AND
       b-aa-fin_account.ind_vat-per-line = TRUE
    THEN DO:

      FOR EACH baa-purchase_invoice WHERE
               baa-purchase_invoice.companycode = sp-company.companycode  
           AND baa-purchase_invoice.acc_year = 2013
               NO-LOCK:

        FOR EACH baa-purchase_invoice_item WHERE
                 baa-purchase_invoice_item.companycode = baa-purchase_invoice.companycode
             AND baa-purchase_invoice_item.invoicenr = baa-purchase_invoice.invoicenr
             AND baa-purchase_invoice_item.vatcode <> ''
                 EXCLUSIVE-LOCK
        TRANSACTION :

          IF baa-purchase_invoice_item.vat-percentage <> 0 AND
             baa-purchase_invoice_item.invoicevalue <> 0   AND
             baa-purchase_invoice_item.vat_value = 0
          THEN DO:
            dVatAmt = ROUND( DECIMAL(baa-purchase_invoice_item.invoicevalue) 
                          * (DECIMAL(baa-purchase_invoice_item.vat-percentage) / 100),2).

            ASSIGN baa-purchase_invoice_item.vat_value = dVatAmt.

            iDone = iDone  + 1.
		    IF iDone MODULO iModulo = 0 
			THEN RUN DisplayProgress (cProgram, cAction, '', 0, iDone).
          END.
        END.
      END.
    END.
  END.

  RUN DisplayProgress (cProgram, cAction, ''    , 0     , iDone).
  
