{System/conversion/conversion_progress.i}

DEFINE VARIABLE cProgram  AS CHARACTER NO-UNDO FORMAT "x(50)".
DEFINE VARIABLE cAction   AS CHARACTER NO-UNDO FORMAT "X(50)".
DEFINE VARIABLE cTable    AS CHARACTER NO-UNDO FORMAT "X(50)".
DEFINE VARIABLE iTotal    AS INTEGER   NO-UNDO.
DEFINE VARIABLE iDone     AS INTEGER   NO-UNDO.
DEFINE VARIABLE iTel      AS INTEGER   NO-UNDO.

DEFINE VARIABLE gcLijst                AS CHARACTER NO-UNDO.
DEFINE VARIABLE gcLijstNew             AS CHARACTER NO-UNDO.
DEFINE VARIABLE gcUpdate               AS CHARACTER NO-UNDO.
DEFINE VARIABLE giUpdate               AS INTEGER   NO-UNDO.
DEFINE VARIABLE giNew                  AS INTEGER   NO-UNDO.
DEFINE VARIABLE gcCompanyCode          AS CHARACTER NO-UNDO.
DEFINE VARIABLE gcVisitHandlingMailBox AS CHARACTER NO-UNDO.
DEFINE VARIABLE gcParameter            AS CHARACTER NO-UNDO.

/* ************************  Function Prototypes ********************** */
FUNCTION spGetEntry RETURNS CHARACTER 
	(INPUT pcLabel      AS CHAR,
	 INPUT pcValueList  AS CHAR,
	 INPUT pcSep1       AS CHAR,
	 INPUT pcSep2       AS CHAR) FORWARD.
	 
/* *********************** main block ********************************* */	
 
ASSIGN
  cProgram = THIS-PROCEDURE:FILE-NAME
  cAction  = "Counting notification settings"
  cTable   = "aa-notification_setting"
  iTotal   = 0
  iDone    = 0.

trans-block:
DO TRANSACTION ON ERROR UNDO, LEAVE
               ON STOP  UNDO, LEAVE.  
   
  RUN update_aa-systemcode.
  
  RUN update_notification_preregconfirm_org.
  iTel  = iTel + 1.
  iDone = iDone + 1.
  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  
  RUN update_notification_blockconfirm_org.
  iTel  = iTel + 1.
  iDone = iDone + 1.
  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  
  RUN update_gatedrivernotify_org.
  iTel  = iTel + 1.
  iDone = iDone + 1.
  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  
  RUN update_notification_preadvetaearly_org.
  iTel  = iTel + 1.
  iDone = iDone + 1.
  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  
  RUN update_notification_preadvetalate_org.
  iTel  = iTel + 1.
  iDone = iDone + 1.
  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  
  RUN update_notification_preadvavailchange_org.
  iTel  = iTel + 1.
  iDone = iDone + 1.
  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  
  RUN update_notification_outordcancel_org.
  iTel  = iTel + 1.
  iDone = iDone + 1.
  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  
  RUN update_notification_visitcancel_org.
  iTel  = iTel + 1.
  iDone = iDone + 1.
  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  
  /* Kloosterboer specifiek */
  FIND sp-control WHERE sp-control.controlkode = "KBCP-1703-CONVERSION" EXCLUSIVE-LOCK NO-ERROR.
  IF NOT AVAIL sp-control THEN LEAVE trans-block.
  
  gcParameter = sp-control.lijst.
  gcCompanyCode          = spGetEntry("CompanyCode"         , gcParameter, ",", "=").
  gcVisitHandlingMailBox = spGetEntry("VisitHandlingMailBox", gcParameter, ",", "=").
  
  RUN update_notification_preregconfirm.
  iTel  = iTel + 1.
  iDone = iDone + 1.
  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  
  RUN update_notification_blockconfirm.
  iTel  = iTel + 1.
  iDone = iDone + 1.
  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
END.	 

/* **********************  Internal Procedures  *********************** */

PROCEDURE add_field:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF INPUT PARAMETER pc_program_function AS CHAR NO-UNDO.
  DEF INPUT PARAMETER pc_notificationcode AS CHAR NO-UNDO.
  DEF INPUT PARAMETER pc_tablename        AS CHAR NO-UNDO.
  DEF INPUT PARAMETER pc_fieldname        AS CHAR NO-UNDO.
  DEF INPUT PARAMETER pc_des              AS CHAR NO-UNDO.
  DEF INPUT PARAMETER pc_datatype         AS CHAR NO-UNDO.
  DEF INPUT PARAMETER pc_member_of_list   AS CHAR NO-UNDO.
  DEF INPUT PARAMETER pc_subtype          AS CHAR NO-UNDO.
  
  FIND aa-notification_field WHERE aa-notification_field.program_function  = pc_program_function 
                               AND aa-notification_field.notificationcode  = pc_notificationcode 
                               AND aa-notification_field.fieldname         = pc_fieldname EXCLUSIVE-LOCK NO-ERROR.
                               
  IF NOT AVAIL aa-notification_field THEN 
  DO. 
    CREATE aa-notification_field.       
    ASSIGN aa-notification_field.program_function  = pc_program_function
           aa-notification_field.notificationcode  = pc_notificationcode.
  END.
  ASSIGN aa-notification_field.tablename         = pc_tablename       
         aa-notification_field.fieldname         = pc_fieldname       
         aa-notification_field.des               = pc_des             
         aa-notification_field.datatype          = pc_datatype        
         aa-notification_field.member_of_list    = pc_member_of_list  
         aa-notification_field.subtype           = pc_subtype.         

END PROCEDURE.

PROCEDURE content_blockconfirm:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF OUTPUT PARAMETER pcSubject AS CHAR NO-UNDO.
  DEF OUTPUT PARAMETER pcBody    AS CHAR NO-UNDO.
  
  pcSubject = "[%companycode%] - Gate notification: visit [%wm-visit.visit_seqnr%] ([%wm-visit.visit_pinid%]) has been blocked.".
  
  pcBody =
                TRIM('This visit has been blocked at the gate automatically or manually by CS, please take appropriate action(s)            ')
    + CHR(10) + TRIM('----------------------------------------------------------------------------------------------------------------------')
    + CHR(10) + TRIM('V I S I T                                                                                                             ')
    + CHR(10) + TRIM('----------------------------------------------------------------------------------------------------------------------')  
    + CHR(10) + TRIM('Visit no: [%wm-visit.visit_seqnr%]                                                                                    ')
    + CHR(10) + TRIM('Visit ID: [%wm-visit.visit_pinid%]                                                                                    ')
    + CHR(10) + TRIM('                                                                                                                      ')
    + CHR(10) + TRIM('----------------------------------------------------------------------------------------------------------------------')    
    + CHR(10) + TRIM('B L O C K   D E T A I L S                                                                                             ')
    + CHR(10) + TRIM('----------------------------------------------------------------------------------------------------------------------')
    + CHR(10) + TRIM('Blocked message code: [%wm-visit.blocked_messagecode%] [%wm-messagecode.des%]                                         ')
    + CHR(10) + TRIM('Date blocked : [%wm-blocked.dt_blocked%] [%wm-blocked.tim_blocked%]                                                   ')
    + CHR(10) + TRIM('                                                                                                                      ')
    + CHR(10) + TRIM('[%wm-visit.blocked_message%]                                                                                          ')
    + CHR(10) + TRIM('                                                                                                                      ')
    + CHR(10) + TRIM('----------------------------------------------------------------------------------------------------------------------')    
    + CHR(10) + TRIM('V I S I T - I T E M                                                                                                   ')
    + CHR(10) + TRIM('----------------------------------------------------------------------------------------------------------------------')
    + CHR(10) + TRIM('Visit item no: [%wm-visit_item.visit_item_seqnr%]                                                                     ')
    + CHR(10) + TRIM('Oder type: [%wm-visit_item.order_typecode%]                                                                           ')
    + CHR(10) + TRIM('Order nr: [%xrefOrdNr%]                                                                                               ')
    + CHR(10) + TRIM('                                                                                                                      ')
    + CHR(10) + TRIM('Remarks:                                                                                                              ')
    + CHR(10) + TRIM('[%xrefRemarks%]                                                                                                       ').
END PROCEDURE.

PROCEDURE content_blockconfirm_org:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF OUTPUT PARAMETER pcSubject AS CHAR NO-UNDO.
  DEF OUTPUT PARAMETER pcBody    AS CHAR NO-UNDO.
  
  pcSubject = "[%companycode%] - Gate notification: visit [%wm-visit.visit_seqnr%] ([%wm-visit.visit_pinid%]) has been blocked.".
  
  pcBody    =
                TRIM('This visit has been blocked at the gate automatically or manually by another employee, please take appropriate action(s)')
    + CHR(10) + TRIM('----------------------------------------------------------------------------------------------------------------------  ')
    + CHR(10) + TRIM('V I S I T                                                                                                               ')
    + CHR(10) + TRIM('----------------------------------------------------------------------------------------------------------------------  ')
    + CHR(10) + TRIM('Visit no: [%wm-visit.visit_seqnr%]                                                                                      ')
    + CHR(10) + TRIM('Visit ID: [%wm-visit.visit_pinid%]                                                                                      ')
    + CHR(10) + TRIM('                                                                                                                        ')
    + CHR(10) + TRIM('----------------------------------------------------------------------------------------------------------------------  ')  
    + CHR(10) + TRIM('B L O C K   D E T A I L S                                                                                               ')
    + CHR(10) + TRIM('----------------------------------------------------------------------------------------------------------------------  ')
    + CHR(10) + TRIM('Blocked message code: [%wm-visit.blocked_messagecode%] [%wm-messagecode.des%]                                           ')
    + CHR(10) + TRIM('Date blocked : [%wm-blocked.dt_blocked%] [%wm-blocked.tim_blocked%]                                                     ')
    + CHR(10) + TRIM('                                                                                                                        ')
    + CHR(10) + TRIM('[%wm-visit.blocked_message%]                                                                                            ')
    + CHR(10) + TRIM('                                                                                                                        ')
    + CHR(10) + TRIM('----------------------------------------------------------------------------------------------------------------------  ')  
    + CHR(10) + TRIM('V I S I T - I T E M                                                                                                     ')
    + CHR(10) + TRIM('----------------------------------------------------------------------------------------------------------------------  ')
    + CHR(10) + TRIM('Visit item no: [%wm-visit_item.visit_item_seqnr%]                                                                       ')
    + CHR(10) + TRIM('Oder type: [%wm-visit_item.order_typecode%]                                                                             ')
    + CHR(10) + TRIM('Order nr: [%xrefOrdNr%]                                                                                                 ')
    + CHR(10) + TRIM('                                                                                                                        ')
    + CHR(10) + TRIM('Remarks:                                                                                                                ')
    + CHR(10) + TRIM('[%xrefRemarks%]                                                                                                         ').
END PROCEDURE.

PROCEDURE content_gatedrivernotify_org:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF OUTPUT PARAMETER pcSubject AS CHAR NO-UNDO.
  DEF OUTPUT PARAMETER pcBody    AS CHAR NO-UNDO.
  
  pcSubject = "".
  pcBody    = "Please return to the gate at [%aa-address.h_name_1%] to resume your check in".

END PROCEDURE.

PROCEDURE content_preadvetaearly_org:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF OUTPUT PARAMETER pcSubject AS CHAR NO-UNDO.
  DEF OUTPUT PARAMETER pcBody    AS CHAR NO-UNDO.

  pcSubject = '[%companycode%]:  Early arrival of order with ordernr: [%wm-out_ord.custref_out1%] and pickup reference: [%wm-out_ord.custref_out2%]'.
  pcBody    =
                  TRIM("Dear [%wm-visit.transportcomp_name%],                                                                                                                             ")
      + CHR(10) + TRIM("                                                                                                                                                                  ")
      + CHR(10) + TRIM("Order with ordernr: [%wm-out_ord.custref_out1%] and pickup reference: [%wm-out_ord.custref_out2%] has a new ETA. It is now expected to arrive earlier than before.")
      + CHR(10) + TRIM("                                                                                                                                                                  ")
      + CHR(10) + TRIM("                                                                                                                                                                  ")
      + CHR(10) + TRIM("Previous ETA:                                                                                                                                                     ")
      + CHR(10) + TRIM("  Date  : [%xrefOldDtLoading%]                                                                                                                                    ")
      + CHR(10) + TRIM("  Time  : [%xrefOldTimLoading%]                                                                                                                                   ")
      + CHR(10) + TRIM("                                                                                                                                                                  ")
      + CHR(10) + TRIM("New ETA:                                                                                                                                                          ")
      + CHR(10) + TRIM("  Date  : [%wm-out_ord.dt_loading%]                                                                                                                               ")
      + CHR(10) + TRIM("  Time  : [%wm-out_ord.tim_loading%]                                                                                                                              ")
      + CHR(10) + TRIM("                                                                                                                                                                  ")
      + CHR(10) + TRIM("Timeslot you've booked:                                                                                                                                           ")
      + CHR(10) + TRIM("  Date  : [%wm-timeslot.dt_date%]                                                                                                                                 ")
      + CHR(10) + TRIM("  Time  : [%wm-timeslot.tim_from%] - [%wm-timeslot.tim_to%]                                                                                                       ")
      + CHR(10) + TRIM("                                                                                                                                                                  ")
      + CHR(10) + TRIM("                                                                                                                                                                  ")
      + CHR(10) + TRIM("Since you've booked a timeslot for pickup(s) on this order you might like to change your timeslot on our Visit Preregistration portal.") 
      + CHR(10) + TRIM("To change your timeslot use visit ID: [%wm-visit.visit_pinid%].")
      + CHR(10) + TRIM("                                                                                                                                                                  ")
      + CHR(10) + TRIM("Regards,                                                                                                                                                          ")
      + CHR(10) + TRIM("                                                                                                                                                                  ")
      + CHR(10) + TRIM("[%aa-address.h_name_1%]                                                                                                                                           ").
        
END PROCEDURE.

PROCEDURE content_preadvetalate_org:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF OUTPUT PARAMETER pcSubject AS CHAR NO-UNDO.
  DEF OUTPUT PARAMETER pcBody    AS CHAR NO-UNDO.

  pcSubject = '[%companycode%]:  Late arrival of order with ordernr: [%wm-out_ord.custref_out1%] and pickup reference: [%wm-out_ord.custref_out2%]'.
  pcBody    =
                  TRIM("Dear [%wm-visit.transportcomp_name%]                                                                                                                            ")
      + CHR(10) + TRIM("                                                                                                                                                                ")
      + CHR(10) + TRIM("Order with ordernr: [%wm-out_ord.custref_out1%] and pickup reference: [%wm-out_ord.custref_out2%] has a new ETA. It is now expected to arrive later than before.")
      + CHR(10) + TRIM("                                                                                                                                                                ")
      + CHR(10) + TRIM("Previous ETA:                                                                                                                                                   ")
      + CHR(10) + TRIM("  Date  : [%xrefOldDtLoading%]                                                                                                                                  ")
      + CHR(10) + TRIM("  Time  : [%xrefOldTimLoading%]                                                                                                                                 ")
      + CHR(10) + TRIM("                                                                                                                                                                ")
      + CHR(10) + TRIM("New ETA:                                                                                                                                                        ")
      + CHR(10) + TRIM("  Date  : [%wm-out_ord.dt_loading%]                                                                                                                             ")
      + CHR(10) + TRIM("  Time  : [%wm-out_ord.tim_loading%]                                                                                                                            ")
      + CHR(10) + TRIM("                                                                                                                                                                ")
      + CHR(10) + TRIM("Due to the late arrival we had to cancel your timeslot booking on this order. Please book a new timeslot on our Visit Preregistration portal.                   ")
      + CHR(10) + TRIM("To book a new timeslot use visit ID: [%wm-visit.visit_pinid%].                                                                                                  ")
      + CHR(10) + TRIM("                                                                                                                                                                ")
      + CHR(10) + TRIM("Regards,                                                                                                                                                        ")
      + CHR(10) + TRIM("                                                                                                                                                                ")
      + CHR(10) + TRIM("[%aa-address.h_name_1%]                                                                                                                                         ").
                                                                                                                                                                                   
END PROCEDURE.

PROCEDURE content_preadvavailchange_org:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF OUTPUT PARAMETER pcSubject AS CHAR NO-UNDO.
  DEF OUTPUT PARAMETER pcBody    AS CHAR NO-UNDO.

  pcSubject = '[%companycode%]: Available pickup amounts changed for order with ordernr: [%wm-out_ord.custref_out1%] and pickup reference: [%wm-out_ord.custref_out2%]'.
  pcBody    =
                  TRIM("Dear [%wm-visit.transportcomp_name%]                                                                                                                            ")
      + CHR(10) + TRIM("                                                                                                                                                                ")
      + CHR(10) + TRIM("Available pickup amounts were changed for order with ordernr: [%wm-out_ord.custref_out1%] and pickup reference: [%wm-out_ord.custref_out2%]                     ")
      + CHR(10) + TRIM("                                                                                                                                                                ")
      + CHR(10) + TRIM("There now may be some room left to pickup another order within the timeslot you've booked.                                                                      ")
      + CHR(10) + TRIM("                                                                                                                                                                ")
      + CHR(10) + TRIM("When applicable you can change pickups for the associated visit now. Use visit ID: [%wm-visit.visit_pinid%] to change your pickups.                             ")
      + CHR(10) + TRIM("                                                                                                                                                                ")
      + CHR(10) + TRIM("Regards,                                                                                                                                                        ")
      + CHR(10) + TRIM("                                                                                                                                                                ")
      + CHR(10) + TRIM("[%aa-address.h_name_1%]                                                                                                                                         ").
                                                                                                                                                                                   
END PROCEDURE.

PROCEDURE content_outordcancel_org:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF OUTPUT PARAMETER pcSubject AS CHAR NO-UNDO.
  DEF OUTPUT PARAMETER pcBody    AS CHAR NO-UNDO.

  pcSubject = '[%companycode%]: Order cancelled with ordernr: [%wm-out_ord.custref_out1%] and pickup reference: [%wm-out_ord.custref_out2%]'.
  pcBody    =
                  TRIM("Dear [%wm-visit.transportcomp_name%]                                                                                                                              ")
      + CHR(10) + TRIM("                                                                                                                                                                  ")
      + CHR(10) + TRIM("Order with ordernr: [%wm-out_ord.custref_out1%] and pickup reference: [%wm-out_ord.custref_out2%] has been cancelled.                                             ")
      + CHR(10) + TRIM("                                                                                                                                                                  ")
      + CHR(10) + TRIM("When all orders on the associated visit are cancelled we automatically cancel your visit. You will receive a separate notification when this occurs.              ")
      + CHR(10) + TRIM("Otherwise there now may be some room left to pickup another order within the timeslot you've booked.                                                              ")
      + CHR(10) + TRIM("                                                                                                                                                                  ")
      + CHR(10) + TRIM("When applicable you can change pickups for the associated visit now. Use visit ID: [%wm-visit.visit_pinid%] to change your pickups.                               ")
      + CHR(10) + TRIM("                                                                                                                                                                  ")
      + CHR(10) + TRIM("Regards,                                                                                                                                                          ")
      + CHR(10) + TRIM("                                                                                                                                                                  ")
      + CHR(10) + TRIM("[%aa-address.h_name_1%]                                                                                                                                           ").
                                                                                                                                                                                   
END PROCEDURE.

PROCEDURE content_visitcancel_org:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF OUTPUT PARAMETER pcSubject AS CHAR NO-UNDO.
  DEF OUTPUT PARAMETER pcBody    AS CHAR NO-UNDO.

  pcSubject = '[%companycode%]: Visit cancelled with visit ID: [%wm-visit.visit_pinid%]'.
  pcBody    =
                  TRIM("Dear [%wm-visit.transportcomp_name%]                                                                                                                              ")
      + CHR(10) + TRIM("                                                                                                                                                                  ")
      + CHR(10) + TRIM("Because all orders associated with visit ID: [%wm-visit.visit_pinid%] were cancelled, your visit has been cancelled also.                                         ")
      + CHR(10) + TRIM("                                                                                                                                                                  ")
      + CHR(10) + TRIM("The visit is no longer available on our pre registration web portal and the visit ID can no longer be used for access to our terminal!                            ")
      + CHR(10) + TRIM("                                                                                                                                                                  ")
      + CHR(10) + TRIM("Regards,                                                                                                                                                          ")
      + CHR(10) + TRIM("                                                                                                                                                                  ")
      + CHR(10) + TRIM("[%aa-address.h_name_1%]                                                                                                                                           ").
                                                                                                                                                                                   
END PROCEDURE.

PROCEDURE content_preregconfirm:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF OUTPUT PARAMETER pcSubject AS CHAR NO-UNDO.
  DEF OUTPUT PARAMETER pcBody    AS CHAR NO-UNDO.
  
  pcSubject = "Confirmation visit [%companycode%] [%wm-timeslot.dt_date%] [%wm-timeslot.tim_from%] - [%wm-timeslot.tim_to%]".
  
  pcBody =
                TRIM('CONFIRMATION visit [%aa-address.h_name_1%]                                                                                                               ' )
    + CHR(10) + TRIM('---------------------------------------------------------------                                                                                          ' )
    + CHR(10) + TRIM('VISIT ID                                                                                                                                                 ' )
    + CHR(10) + TRIM('---------------------------------------------------------------                                                                                          ' )
    + CHR(10) + TRIM('Visit ID: [%wm-visit.visit_pinid%]                                                                                                                       ' )
    + CHR(10) + TRIM('The driver needs the Visit ID to be able to check-in at [%aa-address.h_name_1%].                                                                         ' )
    + CHR(10) + TRIM('                                                                                                                                                         ' )
    + CHR(10) + TRIM('Please note that the use of a Cargo Card is mandatory for truck driver visits.                                                                           ' )
    + CHR(10) + TRIM('In case a truck driver is not in the possession of a Cargo Card, a limited access day-pass can be aquired at the office on the lefthand side at the gate.' )
    + CHR(10) + TRIM('Cargo cards can be acquired via Secure Logistics.                                                                                                        ' )
    + CHR(10) + TRIM('                                                                                                                                                         ' )
    + CHR(10) + TRIM('---------------------------------------------------------------                                                                                          ' )
    + CHR(10) + TRIM('T I M E S L O T                                                                                                                                          ' )
    + CHR(10) + TRIM('---------------------------------------------------------------                                                                                          ' )
    + CHR(10) + TRIM('Date: [%wm-timeslot.dt_date%] ( year/month/day )                                                                                                         ' )
    + CHR(10) + TRIM('Timeslot: [%wm-timeslot.tim_from%] - [%wm-timeslot.tim_to%]                                                                                              ' )
    + CHR(10) + TRIM('Check-in open: [%xrefCheckInOpen%]                                                                                                                       ' )
    + CHR(10) + TRIM('Check-in close: [%xrefCheckInClose%]                                                                                                                     ' )
    + CHR(10) + TRIM('Please check-in at " [%aa-address.h_name_1%] " within the timeslot you reserved.                                                                         ' )
    + CHR(10) + TRIM('Early arrivals may be held until the timeslot opens. Late arrivals may be held until a free timeslot opens.                                              ' )
    + CHR(10) + TRIM('                                                                                                                                                         ' )
    + CHR(10) + TRIM('---------------------------------------------------------------                                                                                          ' )
    + CHR(10) + TRIM('A D D R E S S                                                                                                                                            ' )
    + CHR(10) + TRIM('---------------------------------------------------------------                                                                                          ' )
    + CHR(10) + TRIM('[%aa-address.h_name_1%] [%aa-address.companytype%]                                                                                                       ' )
    + CHR(10) + TRIM('[%aa-address.h_address_1%] [%aa-address.h_housenr%]                                                                                                      ' )
    + CHR(10) + TRIM('[%aa-address.h_zipcode%] [%aa-address.h_city%], [%aa-address.h_countrycode%]                                                                             ' )
    + CHR(10) + TRIM('[%aa-address.h_address_2%]                                                                                                                               ' )
    + CHR(10) + TRIM('                                                                                                                                                         ' )
    + CHR(10) + TRIM('---------------------------------------------------------------                                                                                          ' )
    + CHR(10) + TRIM('B O O K I N G   D E T A I L S                                                                                                                            ' )
    + CHR(10) + TRIM('---------------------------------------------------------------                                                                                          ' )
    + CHR(10) + TRIM('Transport company: [%wm-visit.transportcomp_name%]                                                                                                       ' )
    + CHR(10) + TRIM('Cargo card number: [%wm-visitor.document_id%]                                                                                                            ' )
    + CHR(10) + TRIM('Truck driver first name: [%wm-visitor.document_firstname%]                                                                                               ' )
    + CHR(10) + TRIM('Truck driver last name: [%wm-visitor.document_lastname%]                                                                                                 ' )
    + CHR(10) + TRIM('License plate truck: [%wm-visit.vehicle_registration%]                                                                                                   ' )
    + CHR(10) + TRIM('Phone number truck driver: [%wm-visit.driver_phone%]                                                                                                     ' )
    + CHR(10) + TRIM('Email address truck driver: [%wm-visit.driver_email%]                                                                                                    ' )
    + CHR(10) + TRIM('                                                                                                                                                         ' )
    + CHR(10) + TRIM('---------------------------------------------------------------                                                                                          ' )
    + CHR(10) + TRIM('O R D E R   D E T A I L S                                                                                                                                ' )
    + CHR(10) + TRIM('---------------------------------------------------------------                                                                                          ' )
    + CHR(10) + TRIM('[%lstOuttake%]                                                                                                                                           ' )
    + CHR(10) + TRIM('PICKUP                                                                                                                                                   ' )
    + CHR(10) + TRIM('Order nr: [%wm-out_ord.custref_out1%]                                                                                                                    ' )
    + CHR(10) + TRIM('Pickup ref: [%wm-out_ord.custref_out2%]                                                                                                                  ' )
    + CHR(10) + TRIM('Carriers: [%xrefCarriersOut%]                                                                                                                            ' )
    + CHR(10) + TRIM('Delivery address: [%xrefDeliveryAddress%]                                                                                                                ' )
    + CHR(10) + TRIM('Delivery instructions: [%xrefDeliveryInstructions%]                                                                                                      ' )
    + CHR(10) + TRIM('[%/lstOuttake%]                                                                                                                                          ' )
    + CHR(10) + TRIM('                                                                                                                                                         ' )
    + CHR(10) + TRIM('[%lstIntake%]                                                                                                                                            ' )
    + CHR(10) + TRIM('UNLOAD                                                                                                                                                   ' )
    + CHR(10) + TRIM('Order nr: [%wm-in_ord.custref_in1%]                                                                                                                      ' )
    + CHR(10) + TRIM('Delivery ref: [%wm-in_ord.custref_in2%]                                                                                                                  ' )
    + CHR(10) + TRIM('Carriers: [%xrefCarriersIn%]                                                                                                                             ' )
    + CHR(10) + TRIM('[%/lstIntake%]                                                                                                                                           ' ).
                                                                                                                                                                               
END PROCEDURE.

PROCEDURE content_preregconfirm_org:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF OUTPUT PARAMETER pcSubject AS CHAR NO-UNDO.
  DEF OUTPUT PARAMETER pcBody    AS CHAR NO-UNDO.
  
  pcSubject = "Confirmation visit [%companycode%] [%wm-timeslot.dt_date%] [%wm-timeslot.tim_from%] - [%wm-timeslot.tim_to%]".
  
  pcBody =
                TRIM('CONFIRMATION visit [%aa-address.h_name_1%]                                                                   ')
    + CHR(10) + TRIM('---------------------------------------------------------------                                              ')
    + CHR(10) + TRIM('VISIT ID                                                                                                     ')
    + CHR(10) + TRIM('---------------------------------------------------------------                                              ')
    + CHR(10) + TRIM('Visit ID: [%wm-visit.visit_pinid%]                                                                           ')
    + CHR(10) + TRIM('The driver needs the Visit ID to be able to check-in at [%aa-address.h_name_1%].                             ')
    + CHR(10) + TRIM('                                                                                                             ')
    + CHR(10) + TRIM('---------------------------------------------------------------                                              ')
    + CHR(10) + TRIM('T I M E S L O T                                                                                              ')
    + CHR(10) + TRIM('---------------------------------------------------------------                                              ')
    + CHR(10) + TRIM('Date: [%wm-timeslot.dt_date%] ( year/month/day )                                                             ')
    + CHR(10) + TRIM('Timeslot: [%wm-timeslot.tim_from%] - [%wm-timeslot.tim_to%]                                                  ')
    + CHR(10) + TRIM('Check-in open: [%xrefCheckInOpen%]                                                                           ')
    + CHR(10) + TRIM('Check-in close: [%xrefCheckInClose%]                                                                         ')
    + CHR(10) + TRIM('Please check-in at " [%aa-address.h_name_1%] " within the timeslot you reserved.                             ')
    + CHR(10) + TRIM('Early arrivals may be held until the timeslot opens. Late arrivals may be held until a free timeslot opens.  ')
    + CHR(10) + TRIM('                                                                                                             ')
    + CHR(10) + TRIM('---------------------------------------------------------------                                              ')
    + CHR(10) + TRIM('A D D R E S S                                                                                                ')
    + CHR(10) + TRIM('---------------------------------------------------------------                                              ')
    + CHR(10) + TRIM('[%aa-address.h_name_1%] [%aa-address.companytype%]                                                           ')
    + CHR(10) + TRIM('[%aa-address.h_address_1%] [%aa-address.h_housenr%]                                                          ')
    + CHR(10) + TRIM('[%aa-address.h_zipcode%] [%aa-address.h_city%], [%aa-address.h_countrycode%]                                 ')
    + CHR(10) + TRIM('[%aa-address.h_address_2%]                                                                                   ')
    + CHR(10) + TRIM('                                                                                                             ')
    + CHR(10) + TRIM('---------------------------------------------------------------                                              ')
    + CHR(10) + TRIM('B O O K I N G   D E T A I L S                                                                                ')
    + CHR(10) + TRIM('---------------------------------------------------------------                                              ')
    + CHR(10) + TRIM('Transport company: [%wm-visit.transportcomp_name%]                                                           ')
    + CHR(10) + TRIM('Cargo card number: [%wm-visitor.document_id%]                                                                ')
    + CHR(10) + TRIM('Truck driver first name: [%wm-visitor.document_firstname%]                                                   ')
    + CHR(10) + TRIM('Truck driver last name: [%wm-visitor.document_lastname%]                                                     ')
    + CHR(10) + TRIM('License plate truck: [%wm-visit.vehicle_registration%]                                                       ')
    + CHR(10) + TRIM('Phone number truck driver: [%wm-visit.driver_phone%]                                                         ')
    + CHR(10) + TRIM('Email address truck driver: [%wm-visit.driver_email%]                                                        ').

END PROCEDURE.

PROCEDURE remove_field:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF INPUT PARAMETER pc_program_function AS CHAR NO-UNDO.
  DEF INPUT PARAMETER pc_notificationcode AS CHAR NO-UNDO.
  DEF INPUT PARAMETER pc_tablename        AS CHAR NO-UNDO.
  DEF INPUT PARAMETER pc_fieldname        AS CHAR NO-UNDO.
  
  FIND aa-notification_field WHERE aa-notification_field.program_function  = pc_program_function 
                               AND aa-notification_field.notificationcode  = pc_notificationcode 
                               AND aa-notification_field.fieldname         = pc_fieldname 
                               AND aa-notification_field.tablename         = pc_tablename EXCLUSIVE-LOCK NO-WAIT NO-ERROR.
  
  IF AVAIL aa-notification_field THEN DELETE aa-notification_field.

END PROCEDURE.

PROCEDURE update_aa-systemcode:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF VAR iVolgNr AS INT NO-UNDO.
  
  FOR EACH aa-systemcode WHERE aa-systemcode.systemtype = "PROGRAM_FUNCTION" BY aa-systemcode.volgordenr.
    iVolgNr = aa-systemcode.volgordenr.
  END.
  
  FIND aa-systemcode WHERE aa-systemcode.systemtype = "PROGRAM_FUNCTION"
                       AND aa-systemcode.systemcode = "PREADVISE" NO-LOCK NO-ERROR.
  IF NOT AVAIL aa-systemcode THEN 
  DO.
    iVolgNr = iVolgNr + 1.
    CREATE aa-systemcode.
    ASSIGN aa-systemcode.systemtype = "PROGRAM_FUNCTION"
           aa-systemcode.systemcode = "PREADVISE"
           aa-systemcode.volgordenr = iVolgNr.
  END.
  FIND aa-systemcode WHERE aa-systemcode.systemtype = "PROGRAM_FUNCTION"
                       AND aa-systemcode.systemcode = "VISIT_ITEM" NO-LOCK NO-ERROR.
  IF NOT AVAIL aa-systemcode THEN 
  DO.
    iVolgNr = iVolgNr + 1.
    CREATE aa-systemcode.
    ASSIGN aa-systemcode.systemtype = "PROGRAM_FUNCTION"
           aa-systemcode.systemcode = "VISIT_ITEM"
           aa-systemcode.volgordenr = iVolgNr.
  END.
END PROCEDURE.

PROCEDURE update_notification_blockconfirm_org:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF VAR cBody             AS CHAR NO-UNDO.
  DEF VAR cSubject          AS CHAR NO-UNDO.
  
  FIND aa-notification WHERE aa-notification.program_function = "VISIT"
                         AND aa-notification.notificationcode = "BLOCKCONFIRM" NO-LOCK NO-ERROR.
  IF NOT AVAIL aa-notification THEN 
  DO.
    CREATE aa-notification.
    ASSIGN aa-notification.program_function = "VISIT"
           aa-notification.notificationcode = "BLOCKCONFIRM"
           aa-notification.des              = 'Visit Blocked Confirmation'
           aa-notification.date_format      = "system"
           aa-notification.applicatiekode   = "WM".
    RUN content_blockconfirm_org (OUTPUT cSubject, OUTPUT cBody).
    ASSIGN aa-notification.notification_subject = cSubject
           aa-notification.notification_body    = cBody.           
  END.

END PROCEDURE.

PROCEDURE update_notification_preregconfirm.
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF VAR cBody             AS CHAR NO-UNDO.
  DEF VAR cSubject          AS CHAR NO-UNDO.
  
  FIND aa-notification WHERE aa-notification.program_function = "VISIT"
                         AND aa-notification.notificationcode = "PREREGCONFIRM" NO-LOCK NO-ERROR.                      
                         
  FIND aa-notification_setting WHERE aa-notification_setting.program_function = aa-notification.program_function
                                 AND aa-notification_setting.notificationcode = aa-notification.notificationcode
                                 AND aa-notification_setting.companycode      = gcCompanyCode
                                 AND aa-notification_setting.addressnr        = 0
                                 AND aa-notification_setting.settingcode      = "KBCPPREREGCONFIRM" EXCLUSIVE-LOCK NO-ERROR.
  IF AVAIL aa-notification_setting THEN RETURN. 

  CREATE aa-notification_setting.
  ASSIGN aa-notification_setting.program_function = aa-notification.program_function 
         aa-notification_setting.notificationcode = aa-notification.notificationcode 
         aa-notification_setting.companycode      = gcCompanyCode                    
         aa-notification_setting.addressnr        = 0                                
         aa-notification_setting.settingcode      = "KBCPPREREGCONFIRM"
         aa-notification_setting.des              = "KBCP - Visit Pre-registration Confirmation".
  RELEASE aa-notification_setting.       
  
  FIND aa-notification_setting WHERE aa-notification_setting.program_function = aa-notification.program_function
                                 AND aa-notification_setting.notificationcode = aa-notification.notificationcode
                                 AND aa-notification_setting.companycode      = gcCompanyCode
                                 AND aa-notification_setting.addressnr        = 0
                                 AND aa-notification_setting.settingcode      = "KBCPPREREGCONFIRM" EXCLUSIVE-LOCK.
  aa-notification_setting.date_format = "yyyy/mm/dd".                               
                                 
  FIND aa-notification_content WHERE aa-notification_content.notification_setting_seqnr = aa-notification_setting.notification_setting_seqnr  
                                 AND aa-notification_content.languagenr                 = 3 EXCLUSIVE-LOCK NO-ERROR.          

  RUN content_preregconfirm (OUTPUT cSubject, OUTPUT cBody).
  IF NOT AVAIL aa-notification_content THEN 
  DO.
    CREATE aa-notification_content.
    ASSIGN aa-notification_content.notification_setting_seqnr = aa-notification_setting.notification_setting_seqnr
           aa-notification_content.languagenr                 = 3.
  END.
  ASSIGN aa-notification_content.notification_body    = cBody
         aa-notification_content.notification_subject = cSubject.
                  
END PROCEDURE.

PROCEDURE update_gatedrivernotify_org.
  DEF VAR cSubject AS CHAR NO-UNDO.
  DEF VAR cBody    AS CHAR NO-UNDO.
  
  FIND aa-notification WHERE aa-notification.program_function = "VISIT"
                         AND aa-notification.notificationcode = "GATEDRIVERNOTIY" EXCLUSIVE-LOCK NO-ERROR.
  IF AVAIL aa-notification THEN DELETE aa-notification.                       
                         
  FIND aa-notification WHERE aa-notification.program_function = "VISIT"
                         AND aa-notification.notificationcode = "GATEDRIVERNOTIFY" NO-LOCK NO-ERROR.
  IF NOT AVAIL aa-notification THEN 
  DO.
    CREATE aa-notification.
    ASSIGN aa-notification.program_function = "VISIT"
           aa-notification.notificationcode = "GATEDRIVERNOTIFY"
           aa-notification.des              = 'Notify driver about gate access'
           aa-notification.date_format      = "system"
           aa-notification.applicatiekode   = "WM".
    RUN content_gatedrivernotify_org (OUTPUT cSubject, OUTPUT cBody).
    ASSIGN aa-notification.notification_subject = cSubject
           aa-notification.notification_body    = cBody.           
  END.                        
END.

PROCEDURE update_notification_blockconfirm.
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF VAR cBody             AS CHAR NO-UNDO.
  DEF VAR cSubject          AS CHAR NO-UNDO.
  
  FIND aa-notification WHERE aa-notification.program_function = "VISIT"
                         AND aa-notification.notificationcode = "BLOCKCONFIRM" EXCLUSIVE-LOCK.
  aa-notification.address_to = gcVisitHandlingMailBox.
    
  FIND aa-notification_setting WHERE aa-notification_setting.program_function = aa-notification.program_function
                                 AND aa-notification_setting.notificationcode = aa-notification.notificationcode
                                 AND aa-notification_setting.companycode      = gcCompanyCode
                                 AND aa-notification_setting.addressnr        = 0
                                 AND aa-notification_setting.settingcode      = "KBCPBLOCKCONFIRM" EXCLUSIVE-LOCK NO-ERROR.
  IF AVAIL aa-notification_setting THEN RETURN.
  
  CREATE aa-notification_setting.
  ASSIGN aa-notification_setting.program_function = aa-notification.program_function 
         aa-notification_setting.notificationcode = aa-notification.notificationcode 
         aa-notification_setting.companycode      = gcCompanyCode                    
         aa-notification_setting.addressnr        = 0                                
         aa-notification_setting.settingcode      = "KBCPBLOCKCONFIRM"
         aa-notification_setting.des              = "KBCP - Visit Block Confirmation".
  RELEASE aa-notification_setting.       
  
  FIND aa-notification_setting WHERE aa-notification_setting.program_function = aa-notification.program_function
                                 AND aa-notification_setting.notificationcode = aa-notification.notificationcode
                                 AND aa-notification_setting.companycode      = gcCompanyCode
                                 AND aa-notification_setting.addressnr        = 0
                                 AND aa-notification_setting.settingcode      = "KBCPBLOCKCONFIRM" EXCLUSIVE-LOCK. 
  aa-notification_setting.date_format = "yyyy/mm/dd".
  
  FIND aa-notification_content WHERE aa-notification_content.notification_setting_seqnr = aa-notification_setting.notification_setting_seqnr  
                                 AND aa-notification_content.languagenr                 = 3 EXCLUSIVE-LOCK NO-ERROR.          

  RUN content_blockconfirm (OUTPUT cSubject, OUTPUT cBody).
  IF NOT AVAIL aa-notification_content THEN 
  DO.
    CREATE aa-notification_content.
    ASSIGN aa-notification_content.notification_setting_seqnr = aa-notification_setting.notification_setting_seqnr
           aa-notification_content.languagenr                 = 3.
  END.         
  ASSIGN aa-notification_content.notification_body    = cBody
         aa-notification_content.notification_subject = cSubject.

END PROCEDURE.

PROCEDURE update_notification_preregconfirm_org:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF VAR cBody             AS CHAR NO-UNDO.
  DEF VAR cSubject          AS CHAR NO-UNDO.
  
  FIND aa-notification WHERE aa-notification.program_function = "VISIT"
                         AND aa-notification.notificationcode = "PREREGCONFIRM" NO-LOCK NO-ERROR.
  IF NOT AVAIL aa-notification THEN 
  DO.
    CREATE aa-notification.
    ASSIGN aa-notification.program_function = "VISIT"
           aa-notification.notificationcode = "PREREGCONFIRM"
           aa-notification.des              = 'Visit Pre-registration Confirmation'
           aa-notification.date_format      = "system"
           aa-notification.applicatiekode   = "WM".
    RUN content_preregconfirm_org (OUTPUT cSubject, OUTPUT cBody).
    ASSIGN aa-notification.notification_subject = cSubject
           aa-notification.notification_body    = cBody.           
  END. 
                                  
  RUN remove_field ( "VISIT", "PREREGCONFIRM", "aa-address"    , "h_name_1" ).
  RUN remove_field ( "VISIT", "PREREGCONFIRM", "aa-address"    , "companytype" ).
  RUN remove_field ( "VISIT", "PREREGCONFIRM", "aa-address"    , "h_address_1" ).
  RUN remove_field ( "VISIT", "PREREGCONFIRM", "aa-address"    , "h_address_2" ).
  RUN remove_field ( "VISIT", "PREREGCONFIRM", "aa-address"    , "h_zipcode" ).
  RUN remove_field ( "VISIT", "PREREGCONFIRM", "aa-address"    , "h_housenr" ).
  RUN remove_field ( "VISIT", "PREREGCONFIRM", "aa-address"    , "h_city" ).
  RUN remove_field ( "VISIT", "PREREGCONFIRM", "aa-address"    , "h_countrycode" ).
  RUN remove_field ( "VISIT", "PREREGCONFIRM", "wm-visit_item" , "visit_item_seqnr" ).
  RUN remove_field ( "VISIT", "PREREGCONFIRM", "wm-visit_item" , "visit_item_pinid" ).
  
  RUN add_field ("VISIT", "PREREGCONFIRM", ""              , "lstVisitItem"             , "Visit item list"       , "none"     , ""            , "list"    ).
  RUN add_field ("VISIT", "PREREGCONFIRM", "wm-visit_item" , "visit_item_seqnr"         , "Visit item No"         , "character", "lstVisitItem", "listitem").
  RUN add_field ("VISIT", "PREREGCONFIRM", "wm-visit_item" , "visit_item_pinid"         , "Visit item ID"         , "character", "lstVisitItem", "listitem").
  RUN add_field ("VISIT", "PREREGCONFIRM", "wm-visit"      , "trailer_registration"     , "Driver trailer license", "character", "", "normal").
  
  RUN add_field ("VISIT", "PREREGCONFIRM", "", "xrefVisitTerminalCode"           , "Terminal code"                , "character", "", "normal").
  RUN add_field ("VISIT", "PREREGCONFIRM", "", "xrefVisitTerminalDescription"    , "Terminal description"         , "character", "", "normal").
  RUN add_field ("VISIT", "PREREGCONFIRM", "", "xrefVisitTerminalAddrName1"      , "Terminal address name"        , "character", "", "normal").
  RUN add_field ("VISIT", "PREREGCONFIRM", "", "xrefVisitTerminalAddrCompType"   , "Terminal address company type", "character", "", "normal").
  RUN add_field ("VISIT", "PREREGCONFIRM", "", "xrefVisitTerminalAddrAddress1"   , "Terminal address line 1"      , "character", "", "normal").
  RUN add_field ("VISIT", "PREREGCONFIRM", "", "xrefVisitTerminalAddrAddress2"   , "Terminal address line 2"      , "character", "", "normal").
  RUN add_field ("VISIT", "PREREGCONFIRM", "", "xrefVisitTerminalAddrZipcode"    , "Terminal address zipcode"     , "character", "", "normal").
  RUN add_field ("VISIT", "PREREGCONFIRM", "", "xrefVisitTerminalAddrHouseNr"    , "Terminal address housenr"     , "character", "", "normal").
  RUN add_field ("VISIT", "PREREGCONFIRM", "", "xrefVisitTerminalAddrCity"       , "Terminal address city"        , "character", "", "normal").
  RUN add_field ("VISIT", "PREREGCONFIRM", "", "xrefVisitTerminalAddrCountryCode", "Terminal address country code", "character", "", "normal").
  
END PROCEDURE.

PROCEDURE update_notification_preadvetaearly_org:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF VAR cBody             AS CHAR NO-UNDO.
  DEF VAR cSubject          AS CHAR NO-UNDO.
  
  FIND aa-notification WHERE aa-notification.program_function = "PREADVISE"
                         AND aa-notification.notificationcode = "PREADVETAEARLY" NO-LOCK NO-ERROR.
  IF NOT AVAIL aa-notification THEN 
  DO.
    CREATE aa-notification.
    ASSIGN aa-notification.program_function = "PREADVISE"
           aa-notification.notificationcode = "PREADVETAEARLY"
           aa-notification.des              = 'Pre advise order early arrival'
           aa-notification.date_format      = "system"
           aa-notification.applicatiekode   = "WM".
    RUN content_preadvetaearly_org (OUTPUT cSubject, OUTPUT cBody).
    ASSIGN aa-notification.notification_subject = cSubject
           aa-notification.notification_body    = cBody.           
  END. 
  
  RUN add_field ("PREADVISE", "PREADVETAEARLY", "wm-visit"   , "visit_pinid"          , "Visit ID"                     , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVETAEARLY", "wm-visit"   , "visit_seqnr"          , "Visit No"                     , "integer"  , "", "normal").
  RUN add_field ("PREADVISE", "PREADVETAEARLY", "wm-visit"   , "transportcomp_name"   , "Transport company"            , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVETAEARLY", "wm-visit"   , "vehicle_registration" , "Driver truck license"         , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVETAEARLY", "wm-visit"   , "trailer_registration" , "Driver trailer license"       , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVETAEARLY", "wm-visit"   , "driver_email"         , "Driver email"                 , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVETAEARLY", "wm-visit"   , "driver_phone"         , "Driver phone"                 , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVETAEARLY", "wm-visitor" , "document_id"          , "Driver document ID"           , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVETAEARLY", "wm-visitor" , "document_firstname"   , "Driver first name"            , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVETAEARLY", "wm-visitor" , "document_lastname"    , "Driver last name"             , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVETAEARLY", "wm-timeslot", "dt_date"              , "Timeslot date"                , "date"     , "", "normal").
  RUN add_field ("PREADVISE", "PREADVETAEARLY", "wm-timeslot", "tim_from"             , "Timeslot start"               , "character", "", "normal").   
  RUN add_field ("PREADVISE", "PREADVETAEARLY", "wm-timeslot", "tim_to"               , "Timeslot end"                 , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVETAEARLY", "wm-out_ord" , "custref_out1"         , "Outtake customer ordernr"     , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVETAEARLY", "wm-out_ord" , "custref_out2"         , "Outtake customer pickup ref"  , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVETAEARLY", "wm-out_ord" , "dt_loading"           , "Outtake loading date"         , "date"     , "", "normal").
  RUN add_field ("PREADVISE", "PREADVETAEARLY", "wm-out_ord" , "tim_loading"          , "Outtake loading time"         , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVETAEARLY", ""           , "xrefCheckInOpen"      , "Timeslot checkin open"        , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVETAEARLY", ""           , "xrefCheckInClose"     , "Timeslot checkin close"       , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVETAEARLY", ""           , "xrefOldDtLoading"     , "Outtake previous loading date", "date"     , "", "normal").
  RUN add_field ("PREADVISE", "PREADVETAEARLY", ""           , "xrefOldTimLoading"    , "Outtake previous loading time", "character", "", "normal").

END PROCEDURE.

PROCEDURE update_notification_preadvetalate_org:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF VAR cBody             AS CHAR NO-UNDO.
  DEF VAR cSubject          AS CHAR NO-UNDO.
  
  FIND aa-notification WHERE aa-notification.program_function = "PREADVISE"
                         AND aa-notification.notificationcode = "PREADVETALATE" NO-LOCK NO-ERROR.
  IF NOT AVAIL aa-notification THEN 
  DO.
    CREATE aa-notification.
    ASSIGN aa-notification.program_function = "PREADVISE"
           aa-notification.notificationcode = "PREADVETALATE"
           aa-notification.des              = 'Pre advise order late arrival'
           aa-notification.date_format      = "system"
           aa-notification.applicatiekode   = "WM".
    RUN content_preadvetalate_org (OUTPUT cSubject, OUTPUT cBody).
    ASSIGN aa-notification.notification_subject = cSubject
           aa-notification.notification_body    = cBody.           
  END. 
  
  RUN add_field ("PREADVISE", "PREADVETALATE", "wm-visit"   , "visit_pinid"          , "Visit ID"                     , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVETALATE", "wm-visit"   , "visit_seqnr"          , "Visit No"                     , "integer"  , "", "normal").
  RUN add_field ("PREADVISE", "PREADVETALATE", "wm-visit"   , "transportcomp_name"   , "Transport company"            , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVETALATE", "wm-visit"   , "vehicle_registration" , "Driver truck license"         , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVETALATE", "wm-visit"   , "trailer_registration" , "Driver trailer license"       , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVETALATE", "wm-visit"   , "driver_email"         , "Driver email"                 , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVETALATE", "wm-visit"   , "driver_phone"         , "Driver phone"                 , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVETALATE", "wm-visitor" , "document_id"          , "Driver document ID"           , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVETALATE", "wm-visitor" , "document_firstname"   , "Driver first name"            , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVETALATE", "wm-visitor" , "document_lastname"    , "Driver last name"             , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVETALATE", "wm-out_ord" , "custref_out1"         , "Outtake customer ordernr"     , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVETALATE", "wm-out_ord" , "custref_out2"         , "Outtake customer pickup ref"  , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVETALATE", "wm-out_ord" , "dt_loading"           , "Outtake loading date"         , "date"     , "", "normal").
  RUN add_field ("PREADVISE", "PREADVETALATE", "wm-out_ord" , "tim_loading"          , "Outtake loading time"         , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVETALATE", ""           , "xrefOldDtLoading"     , "Outtake previous loading date", "date"     , "", "normal").
  RUN add_field ("PREADVISE", "PREADVETALATE", ""           , "xrefOldTimLoading"    , "Outtake previous loading time", "character", "", "normal").

END PROCEDURE.

PROCEDURE update_notification_preadvavailchange_org:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF VAR cBody             AS CHAR NO-UNDO.
  DEF VAR cSubject          AS CHAR NO-UNDO.
  
  FIND aa-notification WHERE aa-notification.program_function = "PREADVISE"
                         AND aa-notification.notificationcode = "PREADVAVAILCHANGE" NO-LOCK NO-ERROR.
  IF NOT AVAIL aa-notification THEN 
  DO.
    CREATE aa-notification.
    ASSIGN aa-notification.program_function = "PREADVISE"
           aa-notification.notificationcode = "PREADVAVAILCHANGE"
           aa-notification.des              = 'Pre advise change in available pickup amounts'
           aa-notification.date_format      = "system"
           aa-notification.applicatiekode   = "WM".
    RUN content_preadvavailchange_org (OUTPUT cSubject, OUTPUT cBody).
    ASSIGN aa-notification.notification_subject = cSubject
           aa-notification.notification_body    = cBody.           
  END. 
  
  RUN add_field ("PREADVISE", "PREADVAVAILCHANGE", "wm-visit"   , "visit_pinid"          , "Visit ID"                     , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVAVAILCHANGE", "wm-visit"   , "visit_seqnr"          , "Visit No"                     , "integer"  , "", "normal").
  RUN add_field ("PREADVISE", "PREADVAVAILCHANGE", "wm-visit"   , "transportcomp_name"   , "Transport company"            , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVAVAILCHANGE", "wm-visit"   , "vehicle_registration" , "Driver truck license"         , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVAVAILCHANGE", "wm-visit"   , "trailer_registration" , "Driver trailer license"       , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVAVAILCHANGE", "wm-visit"   , "driver_email"         , "Driver email"                 , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVAVAILCHANGE", "wm-visit"   , "driver_phone"         , "Driver phone"                 , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVAVAILCHANGE", "wm-visitor" , "document_id"          , "Driver document ID"           , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVAVAILCHANGE", "wm-visitor" , "document_firstname"   , "Driver first name"            , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVAVAILCHANGE", "wm-visitor" , "document_lastname"    , "Driver last name"             , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVAVAILCHANGE", "wm-out_ord" , "custref_out1"         , "Outtake customer ordernr"     , "character", "", "normal").
  RUN add_field ("PREADVISE", "PREADVAVAILCHANGE", "wm-out_ord" , "custref_out2"         , "Outtake customer pickup ref"  , "character", "", "normal").
  
END PROCEDURE.

PROCEDURE update_notification_outordcancel_org:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF VAR cBody             AS CHAR NO-UNDO.
  DEF VAR cSubject          AS CHAR NO-UNDO.
  
  FIND aa-notification WHERE aa-notification.program_function = "VISIT_ITEM"
                         AND aa-notification.notificationcode = "OUTORDCANCEL" NO-LOCK NO-ERROR.
  IF NOT AVAIL aa-notification THEN 
  DO.
    CREATE aa-notification.
    ASSIGN aa-notification.program_function = "VISIT_ITEM"
           aa-notification.notificationcode = "OUTORDCANCEL"
           aa-notification.des              = 'Outtake order cancelled'
           aa-notification.date_format      = "system"
           aa-notification.applicatiekode   = "WM".
    RUN content_outordcancel_org (OUTPUT cSubject, OUTPUT cBody).
    ASSIGN aa-notification.notification_subject = cSubject
           aa-notification.notification_body    = cBody.           
  END. 
  
  RUN add_field ("VISIT_ITEM", "OUTORDCANCEL", "wm-visit"   , "visit_pinid"          , "Visit ID"                     , "character", "", "normal").
  RUN add_field ("VISIT_ITEM", "OUTORDCANCEL", "wm-visit"   , "visit_seqnr"          , "Visit No"                     , "integer"  , "", "normal").
  RUN add_field ("VISIT_ITEM", "OUTORDCANCEL", "wm-visit"   , "transportcomp_name"   , "Transport company"            , "character", "", "normal").
  RUN add_field ("VISIT_ITEM", "OUTORDCANCEL", "wm-visit"   , "vehicle_registration" , "Driver truck license"         , "character", "", "normal").
  RUN add_field ("VISIT_ITEM", "OUTORDCANCEL", "wm-visit"   , "trailer_registration" , "Driver trailer license"       , "character", "", "normal").
  RUN add_field ("VISIT_ITEM", "OUTORDCANCEL", "wm-visit"   , "driver_email"         , "Driver email"                 , "character", "", "normal").
  RUN add_field ("VISIT_ITEM", "OUTORDCANCEL", "wm-visit"   , "driver_phone"         , "Driver phone"                 , "character", "", "normal").
  RUN add_field ("VISIT_ITEM", "OUTORDCANCEL", "wm-visitor" , "document_id"          , "Driver document ID"           , "character", "", "normal").
  RUN add_field ("VISIT_ITEM", "OUTORDCANCEL", "wm-visitor" , "document_firstname"   , "Driver first name"            , "character", "", "normal").
  RUN add_field ("VISIT_ITEM", "OUTORDCANCEL", "wm-visitor" , "document_lastname"    , "Driver last name"             , "character", "", "normal").
  RUN add_field ("VISIT_ITEM", "OUTORDCANCEL", "wm-out_ord" , "custref_out1"         , "Outtake customer ordernr"     , "character", "", "normal").
  RUN add_field ("VISIT_ITEM", "OUTORDCANCEL", "wm-out_ord" , "custref_out2"         , "Outtake customer pickup ref"  , "character", "", "normal").
  RUN add_field ("VISIT_ITEM", "OUTORDCANCEL", "wm-out_ord" , "dt_loading"           , "Outtake loading date"         , "character", "", "normal").
  RUN add_field ("VISIT_ITEM", "OUTORDCANCEL", "wm-out_ord" , "tim_loading"          , "Outtake loading time"         , "character", "", "normal").

END PROCEDURE.

PROCEDURE update_notification_visitcancel_org:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF VAR cBody             AS CHAR NO-UNDO.
  DEF VAR cSubject          AS CHAR NO-UNDO.
  
  FIND aa-notification WHERE aa-notification.program_function = "VISIT"
                         AND aa-notification.notificationcode = "VISITCANCEL" NO-LOCK NO-ERROR.
  IF NOT AVAIL aa-notification THEN 
  DO.
    CREATE aa-notification.
    ASSIGN aa-notification.program_function = "VISIT"
           aa-notification.notificationcode = "VISITCANCEL"
           aa-notification.des              = 'Visit cancelled'
           aa-notification.date_format      = "system"
           aa-notification.applicatiekode   = "WM".
    RUN content_visitcancel_org (OUTPUT cSubject, OUTPUT cBody).
    ASSIGN aa-notification.notification_subject = cSubject
           aa-notification.notification_body    = cBody.           
  END. 
  
  RUN add_field ("VISIT", "VISITCANCEL", "wm-visit"   , "visit_pinid"          , "Visit ID"                     , "character", ""          , "normal").
  RUN add_field ("VISIT", "VISITCANCEL", "wm-visit"   , "visit_seqnr"          , "Visit No"                     , "integer"  , ""          , "normal").
  RUN add_field ("VISIT", "VISITCANCEL", "wm-visit"   , "transportcomp_name"   , "Transport company"            , "character", ""          , "normal").
  RUN add_field ("VISIT", "VISITCANCEL", "wm-visit"   , "vehicle_registration" , "Driver truck license"         , "character", ""          , "normal").
  RUN add_field ("VISIT", "VISITCANCEL", "wm-visit"   , "trailer_registration" , "Driver trailer license"       , "character", ""          , "normal").
  RUN add_field ("VISIT", "VISITCANCEL", "wm-visit"   , "driver_email"         , "Driver email"                 , "character", ""          , "normal").
  RUN add_field ("VISIT", "VISITCANCEL", "wm-visit"   , "driver_phone"         , "Driver phone"                 , "character", ""          , "normal").
  RUN add_field ("VISIT", "VISITCANCEL", "wm-visitor" , "document_id"          , "Driver document ID"           , "character", ""          , "normal").
  RUN add_field ("VISIT", "VISITCANCEL", "wm-visitor" , "document_firstname"   , "Driver first name"            , "character", ""          , "normal").
  RUN add_field ("VISIT", "VISITCANCEL", "wm-visitor" , "document_lastname"    , "Driver last name"             , "character", ""          , "normal").
  RUN add_field ("VISIT", "VISITCANCEL", "wm-out_ord" , "transportnr"          , "Outtake transportnr"          , "integer"  , ""          , "normal").
  RUN add_field ("VISIT", "VISITCANCEL", ""           , "lstOuttake"           , "Outtake list"                 , "none"     , ""          , "list").
  RUN add_field ("VISIT", "VISITCANCEL", "wm-out_ord" , "custref_out1"         , "Outtake customer ordernr"     , "character", "lstOuttake", "listitem").
  RUN add_field ("VISIT", "VISITCANCEL", "wm-out_ord" , "custref_out2"         , "Outtake customer pickup ref"  , "character", "lstOuttake", "listitem").
  
END PROCEDURE.


/* ************************  Function Implementations ***************** */

FUNCTION spGetEntry RETURNS CHARACTER 
	( INPUT pcLabel      AS CHAR,
      INPUT pcValueList  AS CHAR,
      INPUT pcSep1       AS CHAR,
      INPUT pcSep2       AS CHAR ):
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/	
    DEF VAR cValue AS CHAR NO-UNDO.
    DEF VAR iTel   AS INT  NO-UNDO.
    DEF VAR iPos   AS INT  NO-UNDO.

    ASSIGN pcValuelist = REPLACE(pcValuelist,pcSep2,pcSep1).
      
    iPos = LOOKUP (pcLabel,pcValueList,pcSep1).

    IF iPos MODULO 2 <> 0 /* dan is het een label , anders een waarde */  
    THEN DO:
     cValue = ENTRY(iPos + 1, pcValueList,pcSep1).
    END. /* IF */
    ELSE DO:
      SEARCHBLOCK:
      DO iTel = 1 TO NUM-ENTRIES(pcValueList,pcSep1) BY 2:
         IF ENTRY(iTel, pcValueList,pcSep1)  = pcLabel
         THEN DO: 
           cValue = ENTRY(iTel + 1, pcValueList,pcSep1).
           LEAVE SEARCHBLOCK. 
         END.
      END. /* DO */       
    END. /* ELSE */ 

 RETURN cValue.   /* Function return value. */

		
END FUNCTION.

